package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/operate/models"
	"go-admin/app/operate/service"
	"go-admin/app/operate/service/dto"
	"go-admin/common/actions"
)

type OrgTeamMatch struct {
	api.Api
}

// GetPage <球队>获取比赛列表
// @Summary <球队>获取比赛列表
// @Description <球队>获取比赛列表
// @Tags <球队>比赛
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {string} string  "{"code": 200, "data": [...]}"
// @Router /api/v1/org-team-match [get]
// @Security Bearer
func (e OrgTeamMatch) GetPage(c *gin.Context) {
    req := dto.OrgMatchGetPageReq{}
    s := service.OrgMatch{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.OrgMatch, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取比赛 失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get <球队>获取比赛所有球员
// @Summary <球队>获取比赛所有球员
// @Description <球队>获取比赛所有球员
// @Tags <球队>比赛
// @Param id path string false "id"
// @Success 200 {string} string  {data=models.OrgMatch} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-team-match/get-players/{id} [get]
// @Security Bearer
func (e OrgTeamMatch) GetPlayers(c *gin.Context) {
	req := dto.OrgMatchGetReq{}
	s := service.OrgMatch{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.OrgMatch

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取比赛失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Get <球队>获取比赛已设置球员
// @Summary <球队>获取比赛已设置球员
// @Description <球队>获取比赛已设置球员
// @Tags <球队>比赛
// @Param id path string false "id"
// @Success 200 {string} string  {data=models.OrgMatch} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-team-match/get-players-is-set/{id} [get]
// @Security Bearer
func (e OrgTeamMatch) GetPlayersIsSet(c *gin.Context) {
	req := dto.OrgMatchGetReq{}
	s := service.OrgMatch{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.OrgMatch

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取比赛失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK( object, "查询成功")
}

// Update <球队>修改比赛球员
// @Summary <球队>修改比赛球员
// @Description <球队>修改比赛球员
// @Tags <球队>比赛
// @Accept application/json
// @Product application/json
// @Param data body dto.OrgMatchUpdateReq true "body"
// @Success 200 {string} string  	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/org-team-match/update-players/{id} [put]
// @Security Bearer
func (e OrgTeamMatch) UpdatePlayers(c *gin.Context) {
    req := dto.OrgMatchUpdateReq{}
    s := service.OrgMatch{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改比赛 失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}
